# !/usr/bin/env Python3
# -*- coding: utf-8 -*-
# @Author   : Akili Wang
# @FILE     : evaluate.py
# @Time     : 2022年2月19日   15:25
# @Software : PyCharm
# @Email   : wz19980226@163.com
#   .--,       .--,
#  ( (  \.---./  ) )
#   '.__/o   o\__.'
#      {=  ^  =}
#       >  -  <
#      /       \
#     //       \\                   神兽保佑
#    //|   .   |\\                  代码无bug！
#    "'\       /'"_.-~^`'-.
#       \  _  /--'         `
#     ___)( )(___
#    (((__) (__)))
#    高山仰止，景行行止。虽不能至，心向往之。

from sklearn.metrics import accuracy_score


class Evaluateion:
    def __init__(self):
        pass

    # 获取acc
    def get_acc(self, label, predict):
        return accuracy_score(label, predict)

    # 获取sn
    def get_sn(self, label, predict):
        tp, fp, tn, fn = 0, 0, 0, 0
        for i in range(len(predict)):
            if (label[i] == '1') and (predict[i] == '1'):
                tp += 1
            elif (label[i] == '0') and (predict[i] == '1'):
                fp += 1
            elif (label[i] == '1') and (predict[i] == '0'):
                fn += 1
            else:
                tn += 1
        return tp / (tp + fn)

    # 获取sp
    def get_sp(self, label, predict):
        tp, fp, tn, fn = 0, 0, 0, 0
        for i in range(len(predict)):
            if (label[i] == '1') and (predict[i] == '1'):
                tp += 1
            elif (label[i] == '0') and (predict[i] == '1'):
                fp += 1
            elif (label[i] == '1') and (predict[i] == '0'):
                fn += 1
            else:
                tn += 1
        return tn / (tn + fp)
